﻿//***********************************************************************
//                                                                     
//   Create_and_update_image_folder_library
//Description:Fragt nach einem Ordner mit platzierbaren Dateien und erstellt aus diesen eine Bibliothek
//                                                                     
//   [Ver: 0.1]   [Author: Gerald Singelmann]   [Modif: 10-08-14]
//   [Lang: DE]   [Tested in CS5, should run in CS3 und CS4]   [Creat: 10-08-14]
//                                                                     
//   Bugs & Feedback : gerald{at}cuppascript{dot}com      
//                     www.cuppascript.com    
//                                                                     
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//*********************************************************************

#target "indesign";

main();

function main() {
	var folder = Folder.selectDialog ("Welcher Bilderordner?");
	if (folder != null) {
		var files = folder.getFiles();
		
		var status_window = new Window('palette', 'Progress');
		var status_line = status_window.add('statictext', undefined, 'jetzt gehts los platzhalter text');
		var pbar = status_window.add('progressbar', [12,12,300,24]);
		pbar.maxvalue = files.length;
		
		var doc = app.documents.add();
		var page = doc.pages.firstItem();
		var lib_path = folder.fsName + ".indl";
		var assets = new Array();
		if (File(lib_path).exists) {
			status_line.text = "Vorhandene auslesen"
			status_window.show();
			var lib = app.open(lib_path);
			for (var n = 0; n < lib.assets.length; n++) {
				assets.push(lib.assets.item(n));
			}
		} else {
			var  lib = app.libraries.add(lib_path);
			var assets = new Array();
		}
		var thing, asset, got_it, gips_schon, metadata;
		var dauer = 0;
		status_line.text = "Dateien prüfen";
		status_window.show();
		for ( var n = 0; n < files.length; n++) {
			pbar.value++;
			if (files[n].name.substr(0,1) !="." && files[n].constructor.name != "Folder") {
				gips_schon = false;
				var then = new Date();
				then = then.getTime();
				for (var m = 0; m < assets.length; m++) {
					if ( files[n].name == assets[m].name) {
						gips_schon = true;
					}
				}
				var now = new Date();
				dauer += (now.getTime()-then);
				if (gips_schon == false) {
					try {
						app.scriptPreferences.userInteractionLevel = UserInteractionLevels.NEVER_INTERACT;
						thing = page.place(files[n]);
						app.scriptPreferences.userInteractionLevel = UserInteractionLevels.INTERACT_WITH_ALL;
						got_it = true;
					} catch(e) {
//~ 						$.writeln(e);
//~ 						$.writeln( files[n].name );
						got_it = false;
					}
					if (got_it) {
						status_line.text = n.toString();
						if (thing[0].constructor.name == "Story") {
							asset = lib.store(thing[0].textContainers[0]);
						} else {
							asset = lib.store(thing);
							try {
								metadata = "";
								metadata += thing[0].itemLink.linkXmp.author + ", ";
								metadata += thing[0].itemLink.linkXmp.documentTitle + ", ";
								metadata += thing[0].itemLink.linkXmp.keywords + ", ";
								metadata += thing[0].itemLink.linkXmp.description;
								asset.description = metadata;
							} catch (e) {}
						}
						asset.name = unescape(files[n].name);
						asset.insertLabel("gs_asset_loader", files[n].fsName);
						thing[0].remove();
					}
				}
			}
		}
		status_window.close();
		doc.close(SaveOptions.NO);
//		alert(dauer/1000);
	}
}